Class CreateTimeOffRequest
- All Implemented Interfaces:
SdkPojo,ToCopyableBuilder<CreateTimeOffRequest.Builder,CreateTimeOffRequest>
The request for CreateTimeOff.
-
Nested Class Summary
Nested Classes -
Method Summary
Modifier and TypeMethodDescriptionfinal ApprovalTypeControls who approves the request.final StringControls who approves the request.static CreateTimeOffRequest.Builderbuilder()final StringA unique, case-sensitive identifier that you provide to ensure that the operation completes no more than one time.final StringA description recorded on the time off request.final InstantendAt()The end of the time off window, exclusive.final booleanfinal booleanequalsBySdkFields(Object obj) Indicates whether some other object is "equal to" this one by SDK fields.final <T> Optional<T> getValueForField(String fieldName, Class<T> clazz) Used to retrieve the value of a field from any class that extendsSdkRequest.final inthashCode()final StringThe identifier of the Connect Customer instance.final RuleFailureActionControls what happens when a configured rule fails.final StringControls what happens when a configured rule fails.static Class<? extends CreateTimeOffRequest.Builder> final StringThe identifier of the shift activity that defines the type of time off being requested.final InstantstartAt()The start of the time off window, inclusive.Take this object and create a builder that contains all of the current property values of this object.final StringtoString()Returns a string representation of this object.final StringuserId()The identifier of the user who the time off request is for.Methods inherited from class software.amazon.awssdk.awscore.AwsRequest
overrideConfigurationMethods inherited from interface software.amazon.awssdk.utils.builder.ToCopyableBuilder
copy
-
Method Details
-
instanceId
The identifier of the Connect Customer instance. This can be the ID or the ARN of the instance. You can find the instance ID in the Amazon Resource Name (ARN) of the instance.
- Returns:
- The identifier of the Connect Customer instance. This can be the ID or the ARN of the instance. You can find the instance ID in the Amazon Resource Name (ARN) of the instance.
-
userId
The identifier of the user who the time off request is for. This can be the ID or the ARN of the user.
- Returns:
- The identifier of the user who the time off request is for. This can be the ID or the ARN of the user.
-
shiftActivityId
The identifier of the shift activity that defines the type of time off being requested. This can be the ID or the ARN of the shift activity. It must be a time off activity. Activities that aren't set as Requestable are accepted.
- Returns:
- The identifier of the shift activity that defines the type of time off being requested. This can be the ID or the ARN of the shift activity. It must be a time off activity. Activities that aren't set as Requestable are accepted.
-
startAt
The start of the time off window, inclusive. It must be no earlier than one year before the current date. Connect Customer stores the value as sent, to the millisecond.
- Returns:
- The start of the time off window, inclusive. It must be no earlier than one year before the current date. Connect Customer stores the value as sent, to the millisecond.
-
endAt
The end of the time off window, exclusive. It must be after
StartAtand no later than 24 months after the current date. Connect Customer stores the value as sent, to the millisecond.- Returns:
- The end of the time off window, exclusive. It must be after
StartAtand no later than 24 months after the current date. Connect Customer stores the value as sent, to the millisecond.
-
description
A description recorded on the time off request. If you omit it, the request has no description.
- Returns:
- A description recorded on the time off request. If you omit it, the request has no description.
-
approvalType
Controls who approves the request.
AWAIT_APPROVALwaits for anApproveTimeOfforRejectTimeOffcall.AUTOMATIChas Connect Customer decide the request. For details, seeCreateTimeOff.If the service returns an enum value that is not available in the current SDK version,
approvalTypewill returnApprovalType.UNKNOWN_TO_SDK_VERSION. The raw value returned by the service is available fromapprovalTypeAsString().- Returns:
- Controls who approves the request.
AWAIT_APPROVALwaits for anApproveTimeOfforRejectTimeOffcall.AUTOMATIChas Connect Customer decide the request. For details, seeCreateTimeOff. - See Also:
-
approvalTypeAsString
Controls who approves the request.
AWAIT_APPROVALwaits for anApproveTimeOfforRejectTimeOffcall.AUTOMATIChas Connect Customer decide the request. For details, seeCreateTimeOff.If the service returns an enum value that is not available in the current SDK version,
approvalTypewill returnApprovalType.UNKNOWN_TO_SDK_VERSION. The raw value returned by the service is available fromapprovalTypeAsString().- Returns:
- Controls who approves the request.
AWAIT_APPROVALwaits for anApproveTimeOfforRejectTimeOffcall.AUTOMATIChas Connect Customer decide the request. For details, seeCreateTimeOff. - See Also:
-
ruleFailureAction
Controls what happens when a configured rule fails.
REJECT, the default, records anERRORand ends the requestREJECTED, unless the whole window is in the past.OVERRIDErecords aWARNINGand ends the requestAPPROVED, like the Override time off rules option in the Connect Customer admin website.OVERRIDErequiresAUTOMATIC. WithAWAIT_APPROVAL,OVERRIDEfails withValidationException. Set it onApproveTimeOffinstead.OVERRIDEnever waivesCONFLICTING_TIME_OFF_REQUEST.If the service returns an enum value that is not available in the current SDK version,
ruleFailureActionwill returnRuleFailureAction.UNKNOWN_TO_SDK_VERSION. The raw value returned by the service is available fromruleFailureActionAsString().- Returns:
- Controls what happens when a configured rule fails.
REJECT, the default, records anERRORand ends the requestREJECTED, unless the whole window is in the past.OVERRIDErecords aWARNINGand ends the requestAPPROVED, like the Override time off rules option in the Connect Customer admin website.OVERRIDErequiresAUTOMATIC. WithAWAIT_APPROVAL,OVERRIDEfails withValidationException. Set it onApproveTimeOffinstead.OVERRIDEnever waivesCONFLICTING_TIME_OFF_REQUEST. - See Also:
-
ruleFailureActionAsString
Controls what happens when a configured rule fails.
REJECT, the default, records anERRORand ends the requestREJECTED, unless the whole window is in the past.OVERRIDErecords aWARNINGand ends the requestAPPROVED, like the Override time off rules option in the Connect Customer admin website.OVERRIDErequiresAUTOMATIC. WithAWAIT_APPROVAL,OVERRIDEfails withValidationException. Set it onApproveTimeOffinstead.OVERRIDEnever waivesCONFLICTING_TIME_OFF_REQUEST.If the service returns an enum value that is not available in the current SDK version,
ruleFailureActionwill returnRuleFailureAction.UNKNOWN_TO_SDK_VERSION. The raw value returned by the service is available fromruleFailureActionAsString().- Returns:
- Controls what happens when a configured rule fails.
REJECT, the default, records anERRORand ends the requestREJECTED, unless the whole window is in the past.OVERRIDErecords aWARNINGand ends the requestAPPROVED, like the Override time off rules option in the Connect Customer admin website.OVERRIDErequiresAUTOMATIC. WithAWAIT_APPROVAL,OVERRIDEfails withValidationException. Set it onApproveTimeOffinstead.OVERRIDEnever waivesCONFLICTING_TIME_OFF_REQUEST. - See Also:
-
clientToken
A unique, case-sensitive identifier that you provide to ensure that the operation completes no more than one time. If this token matches a previous request, Connect Customer returns the result of that request and doesn't create another time off request. If you don't provide a token, the AWS SDK populates this field. If you reuse a client token with a different request body, the request fails with
ValidationException. For more information about idempotency, see Making retries safe with idempotent APIs.- Returns:
- A unique, case-sensitive identifier that you provide to ensure that the operation completes no more than
one time. If this token matches a previous request, Connect Customer returns the result of that request
and doesn't create another time off request. If you don't provide a token, the AWS SDK populates this
field. If you reuse a client token with a different request body, the request fails with
ValidationException. For more information about idempotency, see Making retries safe with idempotent APIs.
-
toBuilder
Description copied from interface:ToCopyableBuilderTake this object and create a builder that contains all of the current property values of this object.- Specified by:
toBuilderin interfaceToCopyableBuilder<CreateTimeOffRequest.Builder,CreateTimeOffRequest> - Specified by:
toBuilderin classConnectSchedulingRequest- Returns:
- a builder for type T
-
builder
-
serializableBuilderClass
-
hashCode
public final int hashCode()- Overrides:
hashCodein classAwsRequest
-
equals
- Overrides:
equalsin classAwsRequest
-
equalsBySdkFields
Description copied from interface:SdkPojoIndicates whether some other object is "equal to" this one by SDK fields. An SDK field is a modeled, non-inherited field in anSdkPojoclass, and is generated based on a service model.If an
SdkPojoclass does not have any inherited fields,equalsBySdkFieldsandequalsare essentially the same.- Specified by:
equalsBySdkFieldsin interfaceSdkPojo- Parameters:
obj- the object to be compared with- Returns:
- true if the other object equals to this object by sdk fields, false otherwise.
-
toString
-
getValueForField
Description copied from class:SdkRequestUsed to retrieve the value of a field from any class that extendsSdkRequest. The field name specified should match the member name from the corresponding service-2.json model specified in the codegen-resources folder for a given service. The class specifies what class to cast the returned value to. If the returned value is also a modeled class, theSdkRequest.getValueForField(String, Class)method will again be available.- Overrides:
getValueForFieldin classSdkRequest- Parameters:
fieldName- The name of the member to be retrieved.clazz- The class to cast the returned object to.- Returns:
- Optional containing the casted return value
-
sdkFields
-
sdkFieldNameToField
- Specified by:
sdkFieldNameToFieldin interfaceSdkPojo- Returns:
- The mapping between the field name and its corresponding field.
-